/*
    *
    * This file is taken from libcsys <https://gitlab.com/cubocore/libcsys>
    * Further modifications will be done as per the requirements of DesQ
    * All bug repots are to be filed with DesQ and not libcsys
    *

    *
    * This program is free software; you can redistribute it and/or modify
    * it under the terms of the GNU General Public License as published by
    * the Free Software Foundation; either version 3 of the License, or
    * (at your option) any later version.
    *

    *
    * This program is distributed in the hope that it will be useful,
    * but WITHOUT ANY WARRANTY; without even the implied warranty of
    * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    * GNU General Public License for more details.
    *

    *
    * You should have received a copy of the GNU General Public License
    * along with this program; if not, vsit http://www.gnu.org/licenses/.
    *
*/


#pragma once

#include <QtCore>
#include <QDBusConnection>

class Battery;
typedef QList<Battery> Batteries;

class BatteryManager : public QObject {
	Q_OBJECT

	public:
		static BatteryManager *instance();
		Batteries batteries();

		bool hasBatteries();
		void refreshBatteries();

	private:
		BatteryManager();

		Batteries mBatts;
		bool mHasBatteries;

		static BatteryManager *mBatMan;
};

class Battery {

	public:
		Battery( QString );

		QString name();

		QStringList properties();
		QVariant value( QString );

		bool isValid() const;

	private:
		QStringList mProperties;
		QDBusInterface *iface;
};
